
// C++ code
#include <Servo.h> // load servo library
#include <stdio.h>//load standard inputs
Servo myservo;  // create servo object
int angle = 0;  // declare variable for servo angle
int angle1 = 120;//set servo rest position (whisk out of bowl)
int angle2 = 40;//set servo operating angle (whisk in bowl)
int trigPin = 12;//set trigger pin as 12
int echoPin = 9;//set echo pin as 9
//int dt = 10;    // short delay time 
void setup(){  // setup code tha only runs
  myservo.attach(3);// set servo pin to 3
  Serial.begin(9600);// serial initializer
  pinMode(11, OUTPUT);//set 11 as output pin for h-bridge
  pinMode(9, OUTPUT);//set 9 as output pin for h bridge
  pinMode(4, OUTPUT);//set 4 as output pin for LED
  pinMode(3, OUTPUT);//set 3 as output pin for servo
  pinMode(2, INPUT);//set 2 as input pin for push button
  myservo.write(angle1);//set servo initial position at rest position
  pinMode(trigPin, OUTPUT);//set triggerpin as an output
  pinMode(echoPin, INPUT);//set echopin as an input
  
}

void loop()
{
  long duration, distance;//code for ultrasonic sensor
  digitalWrite(trigPin, LOW);//turn off trigger pin
  delayMicroseconds(2);//wait 2 microseconds
  digitalWrite(trigPin, HIGH);//turn on trigger pin
  delayMicroseconds(10);//wait 10 microseconds
  digitalWrite(trigPin, LOW);//turn off triggerpin
  duration = pulseIn(echoPin, HIGH);//set pulse lenth
  distance = (duration/2) / 29.1;//distance conversion
  Serial.print(distance);//print distance
  Serial.println(" cm");//add units to distance
  
    {
    if(distance<=11){//if the bowl is the correct distance from the sensor under whisk
      digitalWrite(4,HIGH);//turn on LED
      if(digitalRead(2) == HIGH){//if button is pressed
        digitalWrite(4, LOW);//turn off LED
        myservo.write(angle2);//move servo to operating position
        delay(1000);//wait 1 second
        analogWrite(11, 180);//Turn on motorized whisk forward
        digitalWrite(9, LOW);//Do not turn motor backward
        Serial.print("Button has been pressed");//for code testing purposes
        delay(9000);//wait 9 seconds
        Serial.print("10 Seconds Passed");//for testing
        digitalWrite(11, LOW);//turn off motor
        digitalWrite(9, LOW);//turn off motor
        delay(1000);//wait 1 second
        myservo.write(angle1);//put servo back to inital position;
        digitalWrite(4, HIGH);//turn on LED
        }else if(distance>=11){//If bowl is not in correct position
          digitalWrite(4,LOW);//turn off LED
        }
    }
  }
}
